#pragma once
#include <vector>
#include <J3ML/LinearAlgebra.h>
class Bone {
protected:
    std::string name;
    Matrix4x4 matrix;
    float weight;
    Bone* parent;
    std::vector<Bone*> children;
public:
    bool isRootBone();
    bool hasChildren();
    const Matrix4x4& getMatrix();
    void setMatrix(const Matrix4x4& m);
    void appendChild(const Bone& bone);
    unsigned int getDepth(); //The "depth" refers to how far in the bone is on the bonemap. For ex, the fingers would be deeper than the elbow.
    Bone* getParent();
    Bone* getChildByName(const std::string& bName);
    Bone* getChildByNameRecursive(const std::string& bName);
    Bone* getFirstChild();
};